/**
 * 
 */
package blatt4;

/**Diese Klasse repräsentiert einen Knoten des Graphen. Die spezielle Struktur wird von der Implementierung
 * der Breitensuche benötigt.
 * @author rguderlei
 *
 * @param <T> Der Typ des Knoten-Inhalts
 */
public class Node<T> implements Comparable<T>{
    T value;
    int dist;
    
    /**Konstruktor.
     * @param n Inhalt des Knotens
     * @param d Distanz im Graphen, wird von der Breitensuche verwendet
     */
    Node(T n, int d){
            value = n ; dist  = d;
    }
    
    /**Konstruktor
     * @param n Inhalt des Knotens
     */
    public Node(T n){
    	this(n, 0);
    }
    
    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object o){
    		if(o==null) return false;
            if(!(o instanceof Node)) return false;
            return ((Node)o).value.equals(value); 
    }
    
    /* (non-Javadoc)
     * @see java.lang.Object#hashCode()
     */
    public int hashCode(){
    	return value.hashCode();
    }

	/* (non-Javadoc)
	 * @see java.lang.Comparable#compareTo(T)
	 */
	public int compareTo(T o) {
		return equals(o)?0:1;
	}
}
