package blatt4;

import java.util.regex.*;

/**Diese Klasse implementiert einen einfachen Parser zum Parsen der Einträge in der Literatur-Datenbank.
 * Die Methode <code>parse()<code> zerlegt den Eintrag. Beispiel:
 * <p>
 * <code>
 *  String entry, title;<br>
 *  String[] authors;<br>
 * 	entry = "...";<br>
 *  ReferenceParser p = new ReferenceParser();<br>
 * 	p.parse(entry);<br>
 *  authors = p.getAuthors();<br>
 *  title = p.getTitle();<br>
 * <code>
 * </p>
 * @author rguderlei
 *
 */
public class ReferenceParser {
	
	private String[] authors;
	private String title;
	
	/**Konstruktor.
	 * 
	 */
	public ReferenceParser(){
		authors = new String[1];
	}
	
	/**Diese Methode parst den Eintrag.
	 * @param entry 
	 */
	public void parse(String entry){
		Pattern p = Pattern.compile("\\^");
		String[] tmp = p.split(entry);
		
		p = Pattern.compile(";");
		String[] tmp2 = p.split(tmp[0]);
		authors = new String[tmp2.length];
		for(int i = 0; i<tmp2.length; i++) authors[i] = tmp2[i].trim();
		
		p = Pattern.compile("\\.");
		tmp2 = p.split(tmp[1]);
		title = tmp2[0];
		
	}

	static String getName(String author){
		Pattern p = Pattern.compile(",");
		return p.split(author)[0].trim();
	}
	
	/**Diese Methode liefert die Autoren als String-Array zurück. Jeder Eintrag des String-Arrays besteht
	 * aus "Name, Vornamen" des Autors. 
	 * @return den vollen Namen des Autors.
	 */
	public String[] getAuthors() {
		return authors;
	}

	
	/**Diese Methode liefert den Titel der Publikation.
	 * @return den Titel der Publikation.
	 */
	public String getTitle() {
		return title;
	}

}
